<?php
class asadalSocket
{
	var $conf	= array('host' => 'daemon.asadal.com', 'port' => '7787');
	var $sock	= NULL;
	var $packet	= NULL;

	function asadalSocket ($conf=array())
	{
		$confs	= (is_array($conf) == true) ? $conf : $this->conf;
		foreach ($confs as $key => $val)
		{
			$this->conf[$key]	= $val;
		}
	}

	function setConnect ()
	{
		$this->sock	= @fsockopen($this->conf['host'], $this->conf['port'], $errno, $errstr);
		return (!$this->sock) ? false : true;
	}

	function makePaket ($data)
	{
		foreach ($data as $key => $val)
		{
			switch ($key)
			{
				case 'header' :
					$packet[$key]	= sprintf("%d", $val);
					break;
				case 'id' :
				case 'pw' :
					$packet[$key]	= sprintf("%20s", $val);
					break;
				case 'reserve' :
					$packet[$key]	= sprintf("%12s", $val);
					break;
				case 'from' :
					$packet[$key]	= sprintf("%15s", $val);
					break;
				case 'msg' :
					$packet[$key]	= base64_encode(sprintf("%s", $val));
					break;
				case 'phone' :
					$packet[$key]	= sprintf("%s", $val);
					break;
			}
		}
		$msgphone		= $packet['msg'] . ',' . $packet['phone'];
		$packet['str']	= sprintf("%8s", strlen($msgphone));
		$this->packet	= $packet['header'	] . $packet['id'		] . $packet['pw'	]
						. $packet['reserve'	] . $packet['from'		] . $packet['str'	] . $msgphone;
	}

	function socketOpen ()
	{
		return ($this->setConnect()) ? true : false;
	}

	function socketPutData ()
	{
		fputs($this->sock, $this->packet);
	}

	function socketReade ()
	{
		$sockData	= NULL;

		return unserialize(fread($this->sock, 1024*10));
	}

	function delConnect ()
	{
		if ($this->sock) { fclose($this->sock); unset($this->sock); }
	}
}
?>